# coding: utf-8
'''
'''

import json

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from common.htmlhints.htmlHint import htmlHintElement

def datapanel(context, main=None, session=None):

    data = {
        'datapanel': {
            'tab': []
        }
    }

    tab1 = {
        '@id': 1,
        '@name': u'Реестр обр. организаций',
        'element': []
    }

    eduOrganizationGrid = {
        '@id': 'eduOrganizationGrid',
        '@type': 'grid',
        '@subtype': 'JS_PAGE_GRID',
        '@plugin': 'pageDGrid',
        '@proc': 'nci.grid.eduOrganizationGrid.gridData.celesta',
        '@hideOnLoad':'false',
        'proc': [
            {
                '@id':'proc1',
                '@name':'nci.grid.eduOrganizationGrid.gridMeta.celesta',
                '@type':'METADATA'
            },
            {
                '@id':'proc2',
                '@name':'nci.grid.eduOrganizationGrid.gridToolBar.celesta',
                '@type':'TOOLBAR'
            }
        ]
    }

    eduOrganizationCard = {
        '@id': 'eduOrganizationCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.eduOrganizationCard.cardData.celesta',
        '@template':'nci/eduOrganizationCard.xml',
        '@hideOnLoad':'true',
        'proc': {
            '@id':'save',
            '@name':'nci.xform.eduOrganizationCard.cardSave.celesta',
            '@type':'SAVE'
        },
        'related': {
            '@id':'eduOrganizationGrid'
        }
    }
    
    eduOrganizationFilter = {    '@id': 'eduOrganizationFilter',
                                '@type': 'xforms',
                                '@proc': 'nci.xform.eduOrganizationFilter.cardData.celesta',
                                '@template':'nci/eduOrganizationFilter.xml',
                                '@hideOnLoad':'true',
                                '@neverShowInPanel':'true',
                                'proc': {
                                            '@id':'save',
                                            '@name':'nci.xform.eduOrganizationFilter.cardSave.celesta',
                                            '@type':'SAVE'
                                        }
                             }

    eduOrganizationDeleteCard = {
        '@id': 'eduOrganizationDeleteCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.eduOrganizationCard.deleteCardData.celesta',
        '@template': 'delElementStandardCard.xml',
        '@hideOnLoad':'true',
        'proc': {
            '@id':'save',
            '@name':'nci.xform.eduOrganizationCard.deleteCardSave.celesta',
            '@type':'SAVE'
        },
        'related': {
            '@id':'eduOrganizationGrid'
        }
    }
    
    tab1['element'].append(htmlHintElement('edu_org_datapanel'))
    tab1['element'].append(eduOrganizationGrid)
    tab1['element'].append(eduOrganizationCard)
    tab1['element'].append(eduOrganizationDeleteCard)
    tab1['element'].append(eduOrganizationFilter)
    data['datapanel']['tab'].extend([tab1])

    return XMLJSONConverter.jsonToXml(json.dumps(data))
