# coding: utf-8
'''
'''

import json

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from common.htmlhints.htmlHint import htmlHintElement

def datapanel(context, main=None, session=None):

    data = {
        'datapanel': {
            'tab': []
        }
    }

    tab1 = {
        '@id': 1,
        '@name': u'Реестр ФЛ',
        'element': []
    }
    
    personFilter = {
        '@id': 'personFilter',
        '@type': 'xforms',
        '@proc': 'nci.xform.personFilter.cardData.celesta',
        '@template':'nci/personFilter.xml'
    }

    personGrid = {
        '@id': 'personGrid',
        '@type': 'grid',
        '@subtype': 'JS_PAGE_GRID',
        '@plugin': 'pageDGrid',
        '@proc': 'nci.grid.personGrid.gridData.celesta',
        '@hideOnLoad':'true',
        'proc': [
            {
                '@id':'proc1',
                '@name':'nci.grid.personGrid.gridMeta.celesta',
                '@type':'METADATA'
            },
            {
                '@id':'proc2',
                '@name':'nci.grid.personGrid.gridToolBar.celesta',
                '@type':'TOOLBAR'
            }
        ],
        'related': {
            '@id':'personFilter'
        }
    }

    personCard = {
        '@id': 'personCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.personCard.cardData.celesta',
        '@template':'nci/personCard.xml',
        '@hideOnLoad':'true',
        'proc': {
            '@id':'save',
            '@name':'nci.xform.personCard.cardSave.celesta',
            '@type':'SAVE'
        },
        'related': {
            '@id':'personGrid'
        }
    }

    personDeleteCard = {
        '@id': 'personDeleteCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.personCard.deleteCardData.celesta',
        '@template': 'delElementStandardCard.xml',
        '@hideOnLoad':'true',
        'proc': {
            '@id':'save',
            '@name':'nci.xform.personCard.deleteCardSave.celesta',
            '@type':'SAVE'
        },
        'related': {
            '@id':'personGrid'
        }
    }

    personEduOrganizationGrid = {
        '@id': 'personEduOrganizationGrid',
        '@type': 'grid',
        '@subtype': 'JS_PAGE_GRID',
        '@plugin': 'pageDGrid',
        '@proc': 'nci.grid.personEduOrganizationGrid.gridData.celesta',
        '@hideOnLoad':'true',
        'proc': [
            {
                '@id':'proc1',
                '@name':'nci.grid.personEduOrganizationGrid.gridMeta.celesta',
                '@type':'METADATA'
            },
            {
                '@id':'proc2',
                '@name':'nci.grid.personEduOrganizationGrid.gridToolBar.celesta',
                '@type':'TOOLBAR'
            }
        ],
        'related': {
            '@id':'personGrid'
        }
    }

    personEduOrganizationCard = {
        '@id': 'personEduOrganizationCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.personEduOrganizationCard.cardData.celesta',
        '@template':'nci/personEduOrganizationCard.xml',
        '@hideOnLoad':'true',
        'proc': {
            '@id':'save',
            '@name':'nci.xform.personEduOrganizationCard.cardSave.celesta',
            '@type':'SAVE'
        },
        'related': [
            {'@id':'personEduOrganizationGrid'},
            { '@id':'personGrid'}
        ]
    }

    personEduOrganizationDeleteCard = {
        '@id': 'personEduOrganizationDeleteCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.personEduOrganizationCard.deleteCardData.celesta',
        '@template': 'delElementStandardCard.xml',
        '@hideOnLoad':'true',
        'proc': {
            '@id':'save',
            '@name':'nci.xform.personEduOrganizationCard.deleteCardSave.celesta',
            '@type':'SAVE'
        },
        'related': {
            '@id':'personEduOrganizationGrid'
        }
    }
    
    tab1['element'].append(htmlHintElement('person_method_datapanel'))
    tab1['element'].append(personFilter)
    tab1['element'].append(personGrid)
    tab1['element'].append(personCard)
    tab1['element'].append(personDeleteCard)
    # связи с обр организациями
    tab1['element'].append(personEduOrganizationGrid)
    tab1['element'].append(personEduOrganizationCard)
    tab1['element'].append(personEduOrganizationDeleteCard)
    data['datapanel']['tab'].extend([tab1])

    return XMLJSONConverter.jsonToXml(json.dumps(data))
