# coding: utf-8
'''
'''

import json

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from common.htmlhints.htmlHint import htmlHintElement

def datapanel(context, main=None, session=None):

    data = {
        'datapanel': {
            'tab': []
        }
    }

    tab1 = {
        '@id': 1,
        '@name': u'Специальности',
        'element': []
    }

    specialitiesGrid = {
        '@id': 'specialitiesGrid',
        '@type': 'grid',
        '@subtype': 'JS_PAGE_GRID',
        '@plugin': 'pageDGrid',
        '@proc': 'nci.grid.specialitiesGrid.gridData.celesta',
        '@hideOnLoad':'false',
        'proc': [
            {
                '@id':'proc1',
                '@name':'nci.grid.specialitiesGrid.gridMeta.celesta',
                '@type':'METADATA'
            },
            {
                '@id':'proc2',
                '@name':'nci.grid.specialitiesGrid.gridToolBar.celesta',
                '@type':'TOOLBAR'
            }
        ]
    }

    specialitiesCard = {
        '@id': 'specialitiesCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.specialitiesCard.cardData.celesta',
        '@template':'nci/specialitiesCard.xml',
        '@hideOnLoad':'true',
        'proc': {
            '@id':'save',
            '@name':'nci.xform.specialitiesCard.cardSave.celesta',
            '@type':'SAVE'
        },
        'related': {
            '@id':'specialitiesGrid'
        }
    }

    specialitiesDeleteCard = {
        '@id': 'specialitiesDeleteCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.specialitiesDeleteCard.cardData.celesta',
        '@template': 'delElementStandardCard.xml',
        '@hideOnLoad':'true',
        'proc': {
            '@id':'save',
            '@name':'nci.xform.specialitiesDeleteCard.cardSave.celesta',
            '@type':'SAVE'
        },
        'related': {
            '@id':'specialitiesGrid'
        }
    }
    
    tab1['element'].append(htmlHintElement('specialities_datapanel'))
    tab1['element'].append(specialitiesGrid)
    tab1['element'].append(specialitiesCard)
    tab1['element'].append(specialitiesDeleteCard)
    data['datapanel']['tab'].extend([tab1])

    return XMLJSONConverter.jsonToXml(json.dumps(data))
