# coding: utf-8
'''
Created on 18 февр. 2016 г.

@author: popov_v
'''
from common import grainssettings
from nci._nci_orm import global_settingsCursor


class GeneralSettings():
    u"""Класс работы с общими настройками из grainSettings.xml
    """
    # Статическая переменная класса, в которую сохраняются настройки гранулы.
    # Данная реализация нужна для того, чтобы не обращаться каждый раз к расположенному на жестком диске файлу настроек
    # rainSettings.xml
    settings = {}
    
    globalSettings = {}

    def __init__(self):
        self.settingsInstance = grainssettings.SettingsManager()

    def getGeneralSettings(self, param):
        return self.settingsInstance.getGeneralSettings(param)

    def getMenuStructure(self, parentNode, result):
        for idx in xrange(1, len(self.getGeneralSettings("%s/link" % parentNode)) + 1):
            node = "%s/link[%i]" % (parentNode, idx)
            level = self.getGeneralSettings("%s/@level" % node)[0]
            whereToAdd = result
            if "." in level:
                levelList = level.split(".")
                i = 0
                while i < len(levelList) - 1:
                    if "child" not in whereToAdd[int(levelList[i]) - 1]:
                        whereToAdd[int(levelList[i]) - 1]["child"] = []
                    whereToAdd = whereToAdd[int(levelList[i]) - 1]["child"]
                    i += 1
            whereToAdd.append({
                "name": self.getGeneralSettings("%s/@name" % node)[0],
                "caption": self.getGeneralSettings("%s/@caption" % node)[0]})
            if self.getGeneralSettings("%s/@value" % node):
                whereToAdd[-1]["value"] = self.getGeneralSettings("%s/@value" % node)[0]
            if self.getGeneralSettings("%s/@target" % node):
                whereToAdd[-1]["target"] = self.getGeneralSettings("%s/@target" % node)[0]
            if self.getGeneralSettings("%s/@selected" % node):
                whereToAdd[-1]["selected"] = self.getGeneralSettings("%s/@selected" % node)[0]


    def getSettingsJSON(self):
        u""" Функция получения JSON'а общих настроек
        """
        if self.settings == {}:
            # Если переменная настроек self.settings пуста,
            # получаем настройки из общего файла настроек grainSettings.xml
            self.settings['configuration'] = self.getGeneralSettings("configuration")[0]
            # отбираем настройки веб-сервисов конфигураций
            self.settings['webServiceSettings'] = {}
            # for conf in ('medstaff', 'management'):
            for idx in range(len(self.getGeneralSettings("webServiceSettings"))):
                conf = self.getGeneralSettings("webServiceSettings[%d]/@configuration" % (idx + 1))[0]
                names = self.getGeneralSettings("webServiceSettings[%d]/parameter/@name" % (idx + 1))
                values = self.getGeneralSettings("webServiceSettings[%d]/parameter/@value" % (idx + 1))
                settingsJson = {}
                for i in range(len(names)):
                    settingsJson[names[i]] = values[i]
                if conf not in self.settings['webServiceSettings']:
                    self.settings['webServiceSettings'][conf] = []
                self.settings['webServiceSettings'][conf].append(settingsJson)
            # локальный ФРМР
            self.settings['localFRMRService'] = {
                'url': self.getGeneralSettings("localFRMRService/parameter[@name='url']/@value")[0]}
            # SMTP сервер
            self.settings['smtpServer'] = \
                dict(mailfrom=self.getGeneralSettings("smtpServer/mailfrom")[0],
                     smtphost=self.getGeneralSettings("smtpServer/smtphost")[0],
                     port=self.getGeneralSettings("smtpServer/port")[0],
                     isauth=self.getGeneralSettings("smtpServer/isauth")[0] in ('True', 'true', '1'),
                     login=self.getGeneralSettings("smtpServer/login")[0],
                     password=self.getGeneralSettings("smtpServer/password")[0],
                     )
            # ссылки в меню (хэдер)
            self.settings['menuLinks'] = []
            self.getMenuStructure(parentNode="menuLinks", result=self.settings['menuLinks'])

        return self.settings
    
    
    def getGlobalSettings(self, context, key):
        value = self.globalSettings.get(key)
        if not value:
            global_settings = global_settingsCursor(context)
            if global_settings.tryGet(key):
                value = global_settings.value
            global_settings.close()
            self.globalSettings[key] = value
            
        return value

    