# coding: utf-8
"""
Created on 09.02.2016

@author: m.prudyvus
"""

import json

from common.sysfunctions import toHexForXml, getGridHeight
from nci._nci_orm import vw_accred_centerCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from security.functions import userHasPermission


try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO

def gridData(context, main, add=None, filterinfo=None, session=None, elementId=None,
             sortColumnList=None, firstrecord=None, pagesize=None):

    accred_center = vw_accred_centerCursor(context)

    # сортировка
    if sortColumnList:
        sortName = toHexForXml(sortColumnList[0].id)
        sortType = unicode(sortColumnList[0].sorting).lower()
    else:
        sortName = None

    typeDict = {"region": u"Региональный",
                "federal": u"Федеральный"}
    # Заголовки
    _header = {'uid': ['~~id'],
               'type': [u'Тип'],
               'region_name': [u'Регион'],
               'city_name': [u'Населенный пункт'],
               'address': [u'Почтовый адрес'],
               'website': [u'Сайт'],
               'phone': [u'Контактный телефон'],
               'email': [u'Электронная почта'],

               'properties': [u'properties']
               }
    for column in _header:
        _header[column].append(toHexForXml(_header[column][0]))
        if sortName == _header[column][1]:
            accred_center.orderBy("%s %s" % (column, sortType))

    accred_center.limit(firstrecord - 1, pagesize)

    grid_data = {'records': {'rec':[]}}

    for accred_center in accred_center.iterate():
        row = {}
        for field in _header:
            if field not in  ("properties", "type"):
                row[_header[field][1]] = getattr(accred_center, field)

            row[_header["type"][1]] = typeDict.get(accred_center.type, u"Неизвестный")

        row[_header['properties'][1]] = {'event': {'@name': 'row_single_click',
                                                   'action': {'#sorted': [{'main_context': 'current'},
                                                                          {'datapanel': {'@type': 'current',
                                                                                         '@tab': 'current'}
                                                                           }
                                                                          ]
                                                              }
                                                   }
                                         }
        grid_data['records']['rec'].append(row)

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(grid_data)),
                     None)

def gridMeta(context, main=None, add=None, filterinfo=None, session=None, elementId=None,
             sortColumnList=None):

    accred_center = vw_accred_centerCursor(context)

    # Заголовки
    _header = {'type': [u'Тип'],
               'region_name': [u'Регион'],
               'city_name': [u'Населенный пункт'],
               'address': [u'Почтовый адрес'],
               'website': [u'Сайт'],
               'phone': [u'Контактный телефон'],
               'email': [u'Электронная почта'], }

    grid_settings = {'gridsettings': {'labels': {},
                                      'columns': {'col': []},
                                      'properties': {'@pagesize': 50,
                                                     '@gridWidth': '100%',
                                                     '@gridHeight': getGridHeight(session),
                                                     '@totalCount': accred_center.count(),
                                                     '@profile': 'default.properties'
                                                     },
                                      }
                     }
    # Добавляем поля для отображения в gridsettingss
    grid_settings['gridsettings']['columns']['col'].append({'@id': _header['type'][0]})
    grid_settings['gridsettings']['columns']['col'].append({'@id': _header['region_name'][0]})
    grid_settings['gridsettings']['columns']['col'].append({'@id': _header['city_name'][0]})
    grid_settings['gridsettings']['columns']['col'].append({'@id': _header['address'][0]})
    grid_settings['gridsettings']['columns']['col'].append({'@id': _header['website'][0]})
    grid_settings['gridsettings']['columns']['col'].append({'@id': _header['phone'][0]})
    grid_settings['gridsettings']['columns']['col'].append({'@id': _header['email'][0]})

    return JythonDTO(None,
                     XMLJSONConverter.jsonToXml(json.dumps(grid_settings)))

def gridToolBar(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u"""Тулбар грида аккредитационных центров"""
    session_json = json.loads(session)['sessioncontext']
    grid_context = session_json['related']['gridContext']
    string_bool = lambda x: x and 'false' or 'true'

    # добавление ФЛ
    add_style = string_bool(userHasPermission(context, session_json['sid'], 'addAccredCenter'))
    # редактирование ФЛ
    edit_style = string_bool(userHasPermission(context, session_json['sid'], 'editAccredCenter') and 'currentRecordId' in grid_context)
    # удаление ФЛ
    delete_style = string_bool(userHasPermission(context, session_json['sid'], 'delAccredCenter')  and 'currentRecordId' in grid_context)

    grid_toolbar = {'gridtoolbar': {'#sorted': [{'item': {'@text': u'Добавить',
                                                          '@hint': u'Добавить данные об аккред. центре',
                                                          '@disable': add_style,
                                                          'action': {'@show_in': 'MODAL_WINDOW',
                                                                     '#sorted': [{'main_context': 'current'},
                                                                                 {'modalwindow': {'@caption': u'Добавить запись об аккредитационном центре',
                                                                                                  '@height': '500',
                                                                                                  '@width': '700'}
                                                                                  },
                                                                                 {'datapanel': {'@type': 'current',
                                                                                                '@tab': 'current',
                                                                                                'element': {'@id': 'accredCenterCard',
                                                                                                            'add_context': 'add'
                                                                                                            }
                                                                                                }
                                                                                  }
                                                                                 ]
                                                                     }
                                                          }
                                                 },
                                                {'item': {'@text': u'Редактировать',
                                                          '@hint': u'Редактировать данные об аккред. центре',
                                                          '@disable': edit_style,
                                                          'action': {'@show_in': 'MODAL_WINDOW',
                                                                     '#sorted': [{'main_context': 'current'},
                                                                                 {'modalwindow': {'@caption': u'Редактировать запись об аккредитационном центре',
                                                                                                  '@height': '500',
                                                                                                  '@width': '700'
                                                                                                  }
                                                                                  },
                                                                                 {'datapanel': {'@type': 'current',
                                                                                                '@tab': 'current',
                                                                                                'element': {'@id': 'accredCenterCard',
                                                                                                            'add_context': 'edit'
                                                                                                            }
                                                                                                }
                                                                                  }
                                                                                 ]
                                                                     }
                                                          }
                                                 },
                                                {'item': {'@text': u'Удалить',
                                                          '@hint': u'Удалить данные об аккред. центре',
                                                          '@disable': delete_style,
                                                          'action': {'@show_in': 'MODAL_WINDOW',
                                                                     '#sorted': [{'main_context': 'current'},
                                                                                 {'modalwindow': {'@caption': 'Удалить данные об аккредитационном центре',
                                                                                                  '@height': '150',
                                                                                                  '@width': '400'
                                                                                                  }
                                                                                  },
                                                                                 {'datapanel': {'@type': 'current',
                                                                                                '@tab': 'current',
                                                                                                'element': {'@id': 'accredCenterDeleteCard',
                                                                                                            'add_context': ''
                                                                                                            }
                                                                                                }
                                                                                  }
                                                                                 ]
                                                                     }
                                                          }
                                                 }
                                                ]
                                    }
                    }

    return XMLJSONConverter.jsonToXml(json.dumps(grid_toolbar))
