# coding: utf-8
'''
'''
import security.functions as secfun
import json


def navNCI(context, session):
    u'''Навигатор НСИ.'''

    sid = json.loads(session)['sessioncontext']['sid']
    resultJSON = {"group": {
                    "@id": "nciNavigator",
                    "@name": "НСИ",
                    # "@icon": "navigatorIcons/security.png",
                    "level1":[]}}
    
    u'''Проверка разрешений на формирование навигатора'''
    if secfun.userHasPermission(context, sid, 'persons'):
        resultJSON['group']['level1'].append({'@id': 'persons',
                                              '@name': 'Реестр ФЛ',
                                              'action': {
                                                  '#sorted': [
                                                      {'main_context': 'full'},  # полная функциональность
                                                      {'datapanel': {
                                                          '@type': 'nci.datapanel.personDatapanel.datapanel.cl',
                                                          '@tab': 'firstOrCurrent'}}]}})

    if secfun.userHasPermission(context, sid, 'eduOrganizations'):
        resultJSON['group']['level1'].append({'@id': 'eduOrganizations',
                                              '@name': 'Реестр обр. организаций',
                                              'action': {
                                                  '#sorted': [
                                                      {'main_context': 'current'},
                                                      {'datapanel': {'@type': 'nci.datapanel.eduOrganizationDatapanel.datapanel.cl',
                                                                       '@tab': 'firstOrCurrent'}}]}})

#     if secfun.userHasPermission(context, sid, 'accredCenters'):
#         resultJSON['group']['level1'].append({'@id': 'accredCenters',
#                                               '@name': 'Реестр аккредитационных центров',
#                                               'action': {'main_context': 'current',
#                                                          'datapanel': {'@type': 'nci.datapanel.accredCenterDatapanel.datapanel.cl',
#                                                                        '@tab': 'firstOrCurrent'
#                                                                       }
#                                                         }
#                                               })

    if secfun.userHasPermission(context, sid, 'specialities'):
        resultJSON['group']['level1'].append({'@id': 'specialities',
                                              '@name': 'Специальности',
                                              'action': {
                                                  '#sorted': [
                                                      {'main_context': 'current'},
                                                      {'datapanel': {
                                                          '@type': 'nci.datapanel.specialitiesDatapanel.datapanel.cl',
                                                          '@tab': 'firstOrCurrent'}}]}})
        
    if secfun.userHasPermission(context, sid, "methodPerspective"):    
        resultJSON['group']['level1'].append({'@id': 'global_settings',
                                              '@name': u'Глобальные настройки',
                                              'action': {
                                                  '#sorted': [
                                                      {'main_context': 'current'},
                                                      {'datapanel': {
                                                          '@type': 'nci/global_settings.xml',
                                                          '@tab': 'firstOrCurrent'}}]}})
        
        resultJSON['group']['level1'].append({'@id': 'test_settings',
                                              '@name': u'Конфигуратор теста',
                                              'action': {
                                                  '#sorted': [
                                                      {'main_context': 'current'},
                                                      {'datapanel': {
                                                          '@type': 'nci.datapanel.testSettingsDatapanel.datapanel.cl',
                                                          '@tab': 'firstOrCurrent'}}]}})
    
    if not resultJSON['group']['level1']:
        resultJSON = {"group":None}
    return resultJSON

def welcomeNavigator(context, session):
    u'''Навигатор для титульной страницы'''

    resultJSON = {"group":{"@id": "welcomeNavigator",
                           "@name": "Добро пожаловать",
                           "level1":[]}
                  }
    resultJSON['group']['level1'].append({'@id': 'welcomeNavigatorLevel',
                                          '@name': 'Добро пожаловать',
                                          '@selectOnLoad': "true",
                                          'action': {
                                              '#sorted': [
                                                  {'main_context': 'current'},
                                                  {'datapanel': {
                                                      '@type': 'nci.datapanel.welcomeDatapanel.datapanel.cl',
                                                      '@tab': 'firstOrCurrent'}}]}})
    return resultJSON


def navHeader(context, session=None):
    u'''Заголовок навигатора.'''

    return {"@width": "275px",
            "@hideOnLoad": "false"}


def navHeaderHide(context, session=None):
    u'''Заголовок навигатора.'''

    return {"@width": "275px",
            "@hideOnLoad": "true"}
