# coding: utf-8

from java.util import ArrayList

from nci._nci_orm import activity_kindCursor
import json
from ru.curs.celesta.showcase.utils import XMLJSONConverter

try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO


def procListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''ListAndCount для education_level'''
    filter_data = json.loads(XMLJSONConverter.xmlToJson(params))["schema"]["filter"]
    
    types = filter_data['record']['act_types']['rec']
    if isinstance(types, dict):
        types = [types]
    
    id_list = []
    for type in types:
        id_list.append(type['id'])
    
    activity_kind = activity_kindCursor(context)
    activity_kind.orderBy('name')
    activity_kind.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    activity_kind.setFilter('type_id','|'.join(id_list))
    activity_kind.limit(firstRecord, recordCount)

    count = activity_kind.count()

    recordList = ArrayList()
    for row in activity_kind.iterate():
        record = DataRecord()
        record.id = str(row.id)
        record.name = row.name
        record.addParameter('type',str(row.type_id))
        recordList.add(record)

    return ResultSelectorData(recordList, count)
