# coding: utf-8

from java.util import ArrayList
import json

from edu._edu_orm import vw_module_courseCursor
from nci._nci_orm import vw_cityCursor, vw_regionCursor, edu_organizationCursor, \
    org_addressCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO

def cityList(context, main=None, add=None, filterinfo=None, session=None, params=None,
               curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''Список населенных пунктов'''
    city = vw_cityCursor(context)
    region = vw_regionCursor(context)
    vw_module_course = vw_module_courseCursor(context)
    edu_organization = edu_organizationCursor(context)
    org_address = org_addressCursor(context)
    if params:
        filter_data = json.loads(XMLJSONConverter.xmlToJson(params))["schema"]["filter"]

        if not isinstance(filter_data, list):
            filter_data = [filter_data]

        for filter_item in filter_data:
            if filter_item.get("module_id"):
                vw_module_course.setRange("module_id", filter_item["module_id"])
                city.setRange("city_id", '-1')

                if vw_module_course.count():
                    edu_org_list = ["'%s'" % vw_module_course.course_edu_org_id for vw_module_course in vw_module_course.iterate()]
                    edu_organization.setFilter("uid", "|".join(edu_org_list))

                    if edu_organization.count():
                        address_list = ["'%s'" % edu_organization.address_id for edu_organization in edu_organization.iterate()]
                        org_address.setFilter("address_id", "|".join(address_list))

                        if org_address.count():
                            city_list = ["'%s'" % org_address.city_id for org_address in org_address.iterate()]
                            city.setFilter("city_id", "|".join(city_list))
            if filter_item.get("region_id"):
                city.setRange("region_id", filter_item["region_id"])

    if not city.count():
        context.error(u"Нет доступных городов")

    city.orderBy('city_name')
    city.setFilter('city_name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    city.limit(firstRecord, recordCount)

    recordList = ArrayList()
    for city in city.iterate():
        rec = DataRecord()
        rec.id = str(city.city_id)
        rec.name = city.city_name

        region.setRange("region_id", city.region_id)
        region.first()
        rec.addParameter("region_id", region.region_id)
        rec.addParameter("region_name", region.region_name)
        recordList.add(rec)

    return ResultSelectorData(recordList, 0)

def cityCount(context, main=None, add=None, filterinfo=None, session=None, params=None,
               curValue=None, startsWith=None):
    '''Счетчик населенных пунктов'''
    city = vw_cityCursor(context)
    vw_module_course = vw_module_courseCursor(context)
    edu_organization = edu_organizationCursor(context)
    org_address = org_addressCursor(context)
    if params:
        filter_data = json.loads(XMLJSONConverter.xmlToJson(params))["schema"]["filter"]

        if not isinstance(filter_data, list):
            filter_data = [filter_data]

        for filter_item in filter_data:
            if filter_item.get("module_id"):
                vw_module_course.setRange("module_id", filter_item["module_id"])
                city.setRange("city_id", '-1')

                if vw_module_course.count():
                    edu_org_list = ["'%s'" % vw_module_course.course_edu_org_id for vw_module_course in vw_module_course.iterate()]
                    edu_organization.setFilter("uid", "|".join(edu_org_list))

                    if edu_organization.count():
                        address_list = ["'%s'" % edu_organization.address_id for edu_organization in edu_organization.iterate()]
                        org_address.setFilter("address_id", "|".join(address_list))

                        if org_address.count():
                            city_list = ["'%s'" % org_address.city_id for org_address in org_address.iterate()]
                            city.setFilter("city_id", "|".join(city_list))
            if filter_item.get("region_id"):
                city.setRange("region_id", filter_item["region_id"])
    city.setFilter('city_name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))

    return ResultSelectorData(None, city.count())

