# coding: utf-8

from java.util import ArrayList

from nci._nci_orm import org_subtypeCursor

import json
from ru.curs.celesta.showcase.utils import XMLJSONConverter

try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO


def procListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''ListAndCount для education_level'''
    filter_data = json.loads(XMLJSONConverter.xmlToJson(params))["schema"]["filter"]
    
    main_type_id = int(filter_data['org_type_id'])
    
    org_subtype = org_subtypeCursor(context)
    org_subtype.setRange('main_type',main_type_id)
    org_subtype.orderBy('name')
    org_subtype.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    org_subtype.limit(firstRecord, recordCount)

    count = org_subtype.count()

    recordList = ArrayList()
    for row in org_subtype.iterate():
        record = DataRecord()
        record.id = str(row.id)
        record.name = row.name
        recordList.add(record)

    return ResultSelectorData(recordList, count)
