# coding: utf-8

from java.io import FileInputStream
import os
import warnings

from common.dbutils import DataBaseXMLExchange
from common.sysfunctions import tableCursorImport


def importData(tableInstance, filePath, action):
    u'''Функция загрузки данных в БД'''
    dataStream = FileInputStream(filePath)
    exchange = DataBaseXMLExchange(dataStream, tableInstance)
    exchange.uploadXML(action)
    dataStream.close()

def initTables(context):
    u'''Функция инициализации таблиц'''
    dirPath = os.path.dirname(os.path.abspath(__file__))
    importTables = [{'grain': 'celesta', 'table': 'Roles'},
                    {'grain': 'celesta', 'table': 'Permissions'},

                    {'grain': 'common', 'table': 'numbersSeries', 'action': 'i'},
                    {'grain': 'common', 'table': 'linesOfNumbersSeries', 'action': 'i'},

                    {'grain': 'security', 'table': 'customPermsTypes'},
                    {'grain': 'security', 'table': 'customPerms'},
                    {'grain': 'security', 'table': 'rolesCustomPerms'},

                    {'grain': 'nci', 'table': 'control_form_type'},
                    {'grain': 'nci', 'table': 'cprogram_attr_list'},
                    {'grain': 'nci', 'table': 'education_form'},
                    {'grain': 'nci', 'table': 'edu_event_type'},
                    {'grain': 'nci', 'table': 'education_level'},
                    {'grain': 'nci', 'table': 'staff_scale'},
                    {'grain': 'nci', 'table': 'staff_area'},
                    {'grain': 'nci', 'table': 'status_model'},
                    {'grain': 'nci', 'table': 'status_list'},
                    {'grain': 'nci', 'table': 'status_model_status'},
                    {'grain': 'nci', 'table': 'org_type'},
                    {'grain': 'nci', 'table': 'org_subtype'},
                    {'grain': 'nci', 'table': 'activity_type'},
                    {'grain': 'nci', 'table': 'activity_kind'},
                    # ПОДУМАТЬ как организовать загрузку
                    # {'grain': 'nci', 'table': 'edu_organization'}
                    # {'grain': 'nci', 'table': 'speciality'},
                    ]
    for table in importTables:
        tableInstance = tableCursorImport(table['grain'], table['table'])(context)
        filePath = "%s\\%s.xml" % (dirPath, table['table'])
        if os.path.isfile(filePath):
            importData(tableInstance,
                       filePath,
                       table.get('action', 'ui'))
        else:
            warnings.warn('File "%s" doesn\'t exists' % filePath)
    context.commit()