# coding: utf-8
'''
Created on 04.08.2014
Карточка образовательной организации
@author: v.popov
'''
import json
import uuid

from com.jayway.jsonpath import JsonPath
from fias.xforms.addressSearch import addressSearchDict, addressEditDict, \
    saveAdress
from nci._nci_orm import edu_organizationCursor, org_addressCursor, org_typeCursor, \
    person_edu_organizationCursor, org_subtypeCursor, subtype_by_orgCursor,\
     activity_typeCursor, activity_kindCursor, org_activity_typeCursor, org_activity_kindCursor
from edu._edu_orm import courseCursor, course_cycleCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter


try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO


def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка обр. организации'''

    edu_organization = edu_organizationCursor(context)
    org_address = org_addressCursor(context)
    org_type = org_typeCursor(context)
    org_subtype = org_subtypeCursor(context)
    subtype_by_org = subtype_by_orgCursor(context)
    org_activity_kind = org_activity_kindCursor(context)
    org_activity_type = org_activity_typeCursor(context)
    activity_type = activity_typeCursor(context)
    activity_kind = activity_kindCursor(context)
    
    readonly = 'false'
    if elementId == 'eduOrgInfoCard':
        curr_rec = JsonPath.read(session, "$.sessioncontext.related.gridContext.currentRecordId")
        course = courseCursor(context)
#         course_cycle = course_cycleCursor(context)
#         course_cycle.get(curr_rec)
#         course.get(course_cycle.course_id)
        course.get(curr_rec)
        curr_rec = course.edu_organization_id
        readonly = 'true'
    subtypes = []
    act_types = []
    act_kind = []
    if add == 'edit' or elementId == 'eduOrgInfoCard':
        if add == 'edit':
            curr_rec = JsonPath.read(session, "$.sessioncontext.related.gridContext.currentRecordId")
        edu_organization.get(curr_rec)
        subtypes = {'rec':[]}
        subtype_by_org.setRange('org_id',curr_rec)
        for subtype in subtype_by_org.iterate():
            org_subtype.get(subtype.subtype_id)
            subtypes['rec'].append({'id':org_subtype.id,
                                     'name':org_subtype.name})
        act_types = {'rec':[]}
        org_activity_type.setRange('org_id',curr_rec)
        for org_activity_type in org_activity_type.iterate():
            activity_type.get(org_activity_type.type_id)
            act_types['rec'].append({'id':activity_type.id,
                                     'name':activity_type.name})
        act_kind = {'rec':[]}
        org_activity_kind.setRange('org_id',curr_rec)
        for org_activity_kind in org_activity_kind.iterate():
            activity_kind.get(org_activity_kind.kind_id)
            act_kind['rec'].append({'id':activity_kind.id,
                                     'name':activity_kind.name})
        
        
    if not edu_organization.address_id:
        address = addressSearchDict().get('address')
    else:
        org_address.get(edu_organization.address_id)
        address = addressEditDict(context, org_address).get("address")



    xformsdata = {
        "schema": {
            "@xmlns": "",
            "record": {
                "uid": edu_organization.uid,
                "name": edu_organization.name,
                "org_type_id": edu_organization.org_type_id,
                "shortname": edu_organization.shortname,
                "abbreviation": edu_organization.abbreviation,
                "phone": edu_organization.phone,
                "website": edu_organization.website,
                "email": edu_organization.email,
                "dpo_department": edu_organization.dpo_department,
                "resp_person": edu_organization.resp_person,
                "resp_person_post": edu_organization.resp_person_post,
                "resp_person_phone": edu_organization.resp_person_phone,
                "resp_person_email": edu_organization.resp_person_email,
                "subordinate_ministry": 'true' if edu_organization.subordinate_ministry else 'false',
                "subtypes":subtypes if subtypes else '',
                "act_types": act_types if act_types else '',
                "act_kind": act_kind if act_kind else '',
                "actual": "true" if edu_organization.actual in (True, None) else "false",
                "@readonly":readonly
            },
            "org_type_list": {
                "org_type": [
                    {
                        "@id": org_type.id,
                        "@name": org_type.name
                    } for org_type in org_type.iterate()
                ]
            },
            "address": address
        }
    }

    xformssettings = {
        "properties": {
            "event": [{
                "@name": "single_click",
                "@linkId": "1",
                "action": {
                    "@keep_user_settings": "true",
                    '#sorted': [
                        {"main_context": "current"},
                        {"datapanel": {
                            "@type": "current",
                            "@tab": "current",
                            "element": {
                                "@id": "eduOrganizationGrid",
                                "add_context": ""
                            }
                        }}]
                }
            }]
        }
    }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardSave(context, main=None, add=None, filterinfo=None,
             session=None, elementId=None, xformsdata=None):
    u'''Сохранение данных о ФЛ. '''

    edu_organization = edu_organizationCursor(context)
    org_address = org_addressCursor(context)
    subtype_by_org = subtype_by_orgCursor(context)
    org_activity_type = org_activity_typeCursor(context)
    org_activity_kind = org_activity_kindCursor(context)
    data_dict = json.loads(xformsdata)["schema"]

    if not data_dict["record"]["uid"]:
        # Добавление новой записи в person
        edu_organization.uid = unicode(uuid.uuid4())
    else:
        # Редактирование уже существующей
        edu_organization.get(data_dict["record"]["uid"])

    edu_organization.name = data_dict["record"]["name"]
    edu_organization.shortname = data_dict["record"]["shortname"]
    edu_organization.abbreviation = data_dict["record"]["abbreviation"]
    edu_organization.actual = data_dict["record"]["actual"] == "true"
    edu_organization.org_type_id = int(data_dict["record"]["org_type_id"])
    edu_organization.dpo_department = data_dict["record"]["dpo_department"]
    edu_organization.resp_person = data_dict["record"]["resp_person"]
    edu_organization.resp_person_post = data_dict["record"]["resp_person_post"]
    edu_organization.resp_person_phone = data_dict["record"]["resp_person_phone"]
    edu_organization.resp_person_email = data_dict["record"]["resp_person_email"]
    edu_organization.website = data_dict["record"]["website"]
    edu_organization.phone = data_dict["record"]["phone"]
    edu_organization.email = data_dict["record"]["email"]
    edu_organization.subordinate_ministry = True if data_dict['record']['subordinate_ministry'] == 'true' else False
 
 
   

    
    if not edu_organization.address_id:
        org_address.address_id = uuid.uuid4()
    else:
        org_address.get(edu_organization.address_id)

    saveAdress(org_address, data_dict["address"])

    if not edu_organization.address_id:
        edu_organization.address_id = org_address.address_id
        org_address.insert()
    else:
        org_address.update()

    if not data_dict["record"]["uid"]:
        edu_organization.insert()
    else:
        edu_organization.update()

    if edu_organization.org_type_id:
            subtype_by_org.setRange('org_id',edu_organization.uid)
            subtype_by_org.deleteAll()
            if 'rec' in data_dict['record']['subtypes']:
                subtypes = data_dict["record"]["subtypes"]['rec']
            
                if isinstance(subtypes,dict):
                    subtypes = [subtypes]
                subtype_by_org.org_id = edu_organization.uid
                for rec in subtypes:
                    subtype_by_org.subtype_id = rec['id']
                    subtype_by_org.insert()
                    
    org_activity_type.setRange('org_id',edu_organization.uid)
    org_activity_type.deleteAll()
    if 'rec' in data_dict['record']['act_types']:
        act_types = data_dict["record"]["act_types"]['rec']
    
        if isinstance(act_types,dict):
            act_types = [act_types]
        org_activity_type.org_id = edu_organization.uid
        for rec in act_types:
            org_activity_type.type_id = rec['id']
            org_activity_type.insert()
            
    org_activity_kind.setRange('org_id',edu_organization.uid)
    org_activity_kind.deleteAll()
    if 'rec' in data_dict['record']['act_kind']:
        act_kind = data_dict["record"]["act_kind"]['rec']
    
        if isinstance(act_kind,dict):
            act_kind = [act_kind]
        org_activity_kind.org_id = edu_organization.uid
        for rec in act_kind:
            org_activity_kind.kind_id = rec['id']
            org_activity_kind.insert()


def deleteCardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''
    current_id = JsonPath.read(session, "$.sessioncontext.related.gridContext.currentRecordId")
    person_edu_organization = person_edu_organizationCursor(context)
    person_edu_organization.setRange("edu_organization_id", current_id)

    edu_course = courseCursor(context)
    edu_course.setRange("edu_organization_id", current_id)



    enable_delete = 'false'
    if person_edu_organization.count():
        message = u"""Удаление невозможно.
            Для выбранной организации есть данные в таблице "Сотрудники" """
    elif edu_course.count():
        message = u"""Удаление невозможно.
            Для выбранной организации есть данные в таблице "Курсы" """
    else:
        message = u"""Вы действительно хотите удалить запись
                        об образовательной организации?"""
        enable_delete = 'true'
    # Структура данных
    xforms_data = {
        'schema': {
            '@xmlns': '',
            'data': {
                'form_text': message,
                'enable_delete': enable_delete
            }
        }
    }

    # Первоначальная xforms_settings
    xforms_settings = {
        'properties': {
            'event': [
                {
                    '@name': 'single_click',
                    '@linkId': '1',
                    'action': {
                        '@keep_user_settings': "true",
                        '#sorted': [
                          {'main_context': 'current'},
                          {'datapanel': {
                              '@type': 'current',
                              '@tab': 'current',
                              'element': {
                                  '@id': 'eduOrganizationGrid',
                                  'add_context': ''
                              }
                          }}]
                    }
                }
            ]
        }
    }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))


def deleteCardSave(context, main=None, add=None, filterinfo=None,
                   session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''

    edu_organization = edu_organizationCursor(context)
    org_address = org_addressCursor(context)
    subtype_by_org = subtype_by_orgCursor(context)
    org_activity_type = org_activity_typeCursor(context)
    org_activity_kind = org_activity_kindCursor(context)

    current_id = JsonPath.read(session, "$.sessioncontext.related.gridContext.currentRecordId")

    subtype_by_org.setRange('org_id',current_id)
    subtype_by_org.deleteAll()
    org_activity_type.setRange('org_id',current_id)
    org_activity_type.deleteAll()
    org_activity_kind.setRange('org_id',current_id)
    org_activity_kind.deleteAll()

    edu_organization.get(current_id)
    edu_organization.delete()

    if org_address.tryGet(edu_organization.address_id):
        org_address.delete()
