# coding: utf-8

import json

from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from security.functions import userHasPermission
from nci._nci_orm import person_edu_organizationCursor, edu_organizationCursor

try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO


def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Фильтр по организациям'''
    
    if context.getData().get(elementId,''):
        xformsdata = context.getData()[elementId]
    else:
        bool_values = [{"label":u'Да',
                        "value":'true'},
                       {"label":u'Нет',
                        "value":'false'},
                       {"label":u'Все',
                        'value':'-'}]
        
        xformsdata = {
            "schema": {
                "@xmlns": "",
                "record": {
                    "uid": "",
                    "subordinate_ministry": "-",
                    "actual": "-",
                    "name": "",
                    'bool_values': bool_values,
    
                    "@filter": '1'
                }
            }
        }     
    
    xformssettings = {
        "properties": {
            "event": [{
                    "@name": "single_click",
                    "@linkId": "1",
                    "action": {
                        "@keep_user_settings": "false",
                        '#sorted': [
                            {"main_context": "current"},
                            {"datapanel": {
                                "@type": "current",
                                "@tab": "current",
                                "element": {
                                    "@id": "eduOrganizationGrid",
                                    "add_context": ""
                                }
                            }}]
                    }
                }
            ]
        }
    }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))
    
def cardSave(context, main=None, add=None, filterinfo=None,
             session=None, elementId=None, xformsdata=None):
    context.getData()[elementId] = json.loads(xformsdata)
