# coding: utf-8
'''
Created on 04.08.2014
@author: v.popov
'''
import json
import uuid

from com.jayway.jsonpath import JsonPath
from nci._nci_orm import edu_organizationCursor, person_edu_organizationCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.app.api import MessageType, UserMessage
except:
    from ru.curs.celesta.showcase import JythonDTO


def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка'''
    # person = personCursor(context)
    edu_organization = edu_organizationCursor(context)
    person_edu_organization = person_edu_organizationCursor(context)

    xformsdata = {"schema":  {
                    "@xmlns":"",
                    "record": {
                        "uid": "", 
                        "person_id": JsonPath.read(session, "$.sessioncontext.related.gridContext[?(@.['@id']=='personGrid')].currentRecordId")[0],
                        "edu_organization_id": "",
                        "edu_organization_name": "",
                        "role":""}}}
    
    if add == 'edit':
        rec_id = JsonPath.read(session, "$.sessioncontext.related.gridContext[?(@.['@id']=='personEduOrganizationGrid')].currentRecordId")[0]
        person_edu_organization.get(rec_id)
        xformsdata['schema']['record']['uid'] = rec_id
        xformsdata['schema']['record']['person_id'] = person_edu_organization.person_id
        xformsdata['schema']['record']['edu_organization_id'] = person_edu_organization.edu_organization_id
        edu_organization.get(person_edu_organization.edu_organization_id)
        xformsdata['schema']['record']['edu_organization_name'] = edu_organization.name
        xformsdata['schema']['record']['role'] = person_edu_organization.role

    xformssettings = {"properties": {
                        "event":[
                            {"@name":"single_click", "@linkId": "1",
                             "action": {
                                "@keep_user_settings": "true" if add == 'edit' else "false",
                                '#sorted': [
                                    {"main_context": "current"},
                                    {"datapanel": {
                                        "@type": "current",
                                        "@tab": "current",
                                        "element": {"@id":"personEduOrganizationGrid",
                                        "add_context": ""}}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))
    

def cardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение данных. '''
    person_edu_organization = person_edu_organizationCursor(context)
    data_dict = json.loads(xformsdata)["schema"]["record"]

    if data_dict["uid"] == '':
        # Добавление новой записи в person_edu_organization
        person_edu_organization.uid = uuid.uuid4()
        person_edu_organization.person_id = data_dict["person_id"]
        person_edu_organization.edu_organization_id = data_dict["edu_organization_id"]
        person_edu_organization.role = data_dict["role"]
        person_edu_organization.insert()
    else:
        # Редактирование уже существующей
        person_edu_organization.get(data_dict["uid"])
        person_edu_organization.person_id = data_dict["person_id"]
        person_edu_organization.edu_organization_id = data_dict["edu_organization_id"]
        person_edu_organization.role = data_dict["role"]
        person_edu_organization.update()


def deleteCardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''
    # Структура данных
    xforms_data = {'schema': {
                    '@xmlns': '',
                    'data': {
                        'form_text': 'Вы действительно хотите удалить связь ФЛ и обр. организации?'}}}
    # Первоначальная xforms_settings
    xforms_settings = {'properties': {
                        'event': [
                            {'@name': 'single_click',
                             '@linkId': '1',
                             'action': {
                                '#sorted': [
                                    {'main_context': 'current'},
                                    {'datapanel': {
                                        '@type': 'current',
                                        '@tab': 'current',
                                        'element': {
                                            '@id': 'personEduOrganizationGrid',
                                            'add_context': ''}}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))


def deleteCardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''

    person_edu_organization = person_edu_organizationCursor(context)
    current_id = JsonPath.read(session, "$.sessioncontext.related.gridContext.currentRecordId")
    person_edu_organization.get(current_id)
    person_edu_organization.delete()
