# coding: utf-8

import json
import uuid

from nci._nci_orm import education_levelCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import specialityCursor


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO

def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''

    specialities = specialityCursor(context)
    education_level = education_levelCursor(context)
    session_json = json.loads(session)['sessioncontext']
    string_bool = lambda x: x and 'true' or 'false'

    # Структура данных
    xforms_data = {
        'schema': {
            '@xmlns': '',
            'data': {
                'uid': '',
                'name': '',
                'shortname': '',
                'education_level': {
                    '@id': '',
                    '@name': ''
                },
                'sort': '',
                'is_actual': 'true'
            }
        }
    }
    if (add == 'edit' and 'currentRecordId' in session_json['related']['gridContext']):
        current_id = session_json['related']['gridContext']['currentRecordId']
        specialities.get(current_id)
        xforms_data['schema']['data']['uid'] = specialities.uid
        xforms_data['schema']['data']['name'] = specialities.name
        xforms_data['schema']['data']['shortname'] = (specialities.shortname
                                                      if specialities.shortname else '')
        xforms_data['schema']['data']['education_level']['@id'] = specialities.education_level
        if specialities.education_level:
            education_level.get(specialities.education_level)
            xforms_data['schema']['data']['education_level']['@name'] = education_level.name
        else:
            xforms_data['schema']['data']['education_level']['@name'] = ''
        xforms_data['schema']['data']['sort'] = (specialities.sort
                                                 if specialities.sort else '')
        xforms_data['schema']['data']['is_actual'] = '%s' % str(specialities.is_actual).lower()

    # Первоначальная xforms_settings
    xforms_settings = {
        'properties': {
            'event': [
                {
                    '@name': 'single_click',
                    '@linkId': '1',
                    'action': {
                        '@keep_user_settings': string_bool(True),
                        '#sorted': [
                          {'main_context': 'current'},
                          {'datapanel': {
                              '@type': 'current',
                              '@tab': 'current',
                              'element': {
                                  '@id': 'specialitiesGrid',
                                  'add_context': ''
                              }
                          }}]
                    }
                }
            ]
        }
    }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))


def cardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''

    specialities = specialityCursor(context)
#     education_level = education_levelCursor(context)

    data_dict = json.loads(xformsdata)['schema']['data']

    if add == 'add':
        specialities.uid = uuid.uuid4()
    else:
        specialities.get(data_dict['uid'])
    specialities.name = data_dict['name']
    specialities.shortname = data_dict['shortname']
    specialities.education_level = data_dict['education_level']['@id']
    specialities.sort = data_dict['sort']
    specialities.is_actual = data_dict['is_actual']
    if add == 'add':
        specialities.insert()
    else:
        specialities.update()
